#include <systemc.h>
 enum stati {FETCH, DECODE, EX_R, WB_R, EX_IMM, WB_IMM, EX_BRANCH, EX_LW, EX_SW, MM_LW, WB_LW, MM_SW};

SC_MODULE(dlx_seq_stati) {

 sc_in_clk clk;
 sc_in<bool> rst;
 sc_in<sc_lv<32> > datain;
 sc_out<bool> MemRead;
 sc_out<bool> MemWrite;
 sc_out<unsigned> addr;
 sc_out<sc_lv<32> > dataout;
 
 sc_out<sc_lv<32> > irr;
 sc_out<sc_uint<4> >  st;
 sc_out<sc_uint<6> > iop;

 
 
 
 sc_signal<stati> stato;
 sc_signal<unsigned> PC;
 sc_signal<sc_lv<32> > IR;
 sc_lv<32>  DR;
 sc_lv<32>  *RegFile;
 sc_signal<unsigned>  Target;
 sc_signal<sc_lv<32> >  A;
 sc_signal<sc_lv<32> >  B;
 sc_signal<signed>  Imm;
 sc_signal<sc_lv<32> >  Ris;

 void proc_next_state();

 void proc_seq();

 SC_CTOR(dlx_seq_stati) {
  
  SC_CTHREAD(proc_next_state,clk.pos());
    reset_signal_is(rst,true);
   SC_METHOD(proc_seq);
     sensitive << stato;
     sensitive << rst;

  RegFile=new sc_lv<32>[32];

  }
  
 };
