#include "systemc.h"
#include "alu.h"
#include "tb_alu.h"

int sc_main(int i, char *p[]) {
	
	sc_signal<int> a,b,op,r;
	sc_clock clock("Clock", 20, SC_NS);
	
	alu ALU("ALU");
	ALU(a,b,op,r);

	tb_alu TB("TB");
	TB(clock,a,b,op);

	sc_trace_file *tf=sc_create_vcd_trace_file("alu");
	sc_trace(tf,clock,"CLK");
	sc_trace(tf,a,"A");
	sc_trace(tf,b,"B");
	sc_trace(tf,op,"OP");
	sc_trace(tf,r,"R");

	sc_start(200,SC_NS);

	return 1;
}